<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Componentes</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas gestionar, editar o crear un Componente?
      </div>
    </div>

    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row justify="end" style="margin-right:0px">
          <v-btn
            class="ma-2"
            dark
            tile
            depressed
            color="secondary"
            @click="dialogSincronizar = true"
          >
            Sincronizar
            <v-icon>mdi-sync</v-icon>
          </v-btn>
        </v-row>
        <v-row>
          <v-col
            v-for="(componente, indexComponente) in componentes"
            :key="indexComponente"
            :xs="12"
            :sm="12"
            :md="3"
            :lg="2"
          >
            <v-card class="generalCard pa-4">
              <div>
                <v-btn
                  x-small
                  class="float-left"
                  text
                  icon
                  @click="
                    (dialogDelete = true), (componente_delete = componente)
                  "
                >
                  <v-img
                    max-width="30"
                    src="@/assets/img/delete.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
                <v-btn
                  :to="componente.to"
                  x-small
                  class="float-right"
                  text
                  icon
                >
                  <v-img
                    max-width="30"
                    src="@/assets/img/icoEditar.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
              </div>
              <v-card-text>
                <div class="cardFranqName cardFranqNameLine">
                  {{ componente.descripcion }}
                </div>
                <div class="cardCreacion1">
                  <div>
                    Fecha de creación:
                    {{ moment(componente.fecha_creacion).format("DD/MM/YYYY") }}
                  </div>
                </div>
                <div>
                  <template v-if="componente.es_web == 2">
                    <v-icon large>mdi-cellphone-android</v-icon>
                    Movil
                  </template>
                  <template v-else>
                    <v-icon large>mdi-web</v-icon>
                    Web
                  </template>
                </div>
                <v-footer absolute class="CardCustomAction">
                  <div>
                    URL:
                    {{ componente.modulo }}
                  </div>
                </v-footer>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
      <v-row>
        <v-col :key="cardAddComponente.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAddComponente.to"
            :color="cardAddComponente.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAddComponente.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAddComponente.src"
                :lazy-src="cardAddComponente.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
      <template>
        <v-dialog v-model="dialogDelete" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas eliminar este componente?</strong>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogDelete = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  :class="[{ desac: deletingComponente }]"
                  @click="deleteComponente()"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogSincronizar" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas sincronizar los componentes?</strong>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogSincronizar = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  :class="[{ desac: syncingComponente }]"
                  @click="ucComponentes()"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
    </div>
  </div>
</template>
<script>
import axios from "axios";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "Component-Componentes",
  data() {
    return {
      moment: moment,
      componente_delete: null,
      dialogDelete: false,
      dialogSincronizar: false,
      deletingComponente: false,
      syncingComponente: false,
      cardAddComponente: {
        title: "Crear Componente",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade una nuevo componente a la lista.",
        to: {
          name: "privilegios_flujos_componentes_nuevo",
        },
        color: "#494949",
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios",
          },
        },
        {
          text: "Flujos",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_flujos",
          },
        },
        {
          text: "Componentes",
          disabled: true,
        },
      ],
      componentes: [],
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  methods: {
    getComponentes() {
      var self = this;
      axios
        .get("/modulo/secure/get/")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setComponentes(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setComponentes(data) {
      if (data) {
        data.forEach((itemComponente) => {
          itemComponente.to = {
            name: "privilegios_flujos_componentes_edicion",
            params: {
              componente: this.serviceCommons.objectToBase64(itemComponente),
            },
          };
        });
        this.componentes = data;
      }
    },
    ucComponentes() {
      var self = this;
      const routes = [];
      this.$router.options.routes.forEach((route) => {
        routes.push({
          modulo: route.path,
          descripcion: route.name,
          es_web: 1,
        });
      });
      self.syncingComponente = true;
      axios
        .post("/modulo/secure/cu", routes)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              self.dialogSincronizar = false;
              self.getComponentes();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.syncingComponente = false;
        });
    },
    deleteComponente() {
      var self = this;
      self.deletingComponente = true;
      self.componente_delete.id_empleado_modifica = user.empleado;
      axios
        .delete("/modulo/secure/delete", { data: self.componente_delete })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              self.dialogDelete = false;
              self.getComponentes();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.deletingComponente = false;
        });
    },
  },
  created() {
    this.getComponentes();
  },
};
</script>
